
#include <iostream>

#include <windows.h>
#include <WINIOCTL.H>
#include <initguid.h>
#include <stdio.h>
#include "ptypes.h"
using namespace::std;

int printguid(const GUID &gu) { 
const byte *b=gu.Data4;
	printf("%08lx-%04x-%04x",gu.Data1,gu.Data2,gu.Data3);
	printf("-%02x%02x-",b[0],b[1]);
	for(int i=2;i<8;i++)
		printf("%02x",b[i]);
putchar('\n');
	return 0;
}

#undef DEFINE_GUID

/*#define DEFINE_GUID(PARTITION_ENTRY_UNUSED_GUID,da1,da2,da3, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);*/


#define DEFINE_GUID(label,d1,d2,d3,...) {const char lab[]=#label; GUID v={d1,d2,d3,{__VA_ARGS__}};if(memcmp(&gu,&v,sizeof(v))==0) {printf("%s",lab);return; } ;}
/*
struct udefs {
char label[];
GUID guid;
} def_guid = {

#include <diskguid.h>
};
*/
void printid(GUID &gu) {

#include <diskguid.h>
}
/*
std::ostream& operator<<(std::ostream& os, const GUID &gu)
{
const byte *b=gu.Data4;
os<<hex<<nouppercase; 
//os.fill('0');
os.width(sizeof(gu.Data1)*2);
os.width(sizeof(gu.Data2)*2);
printf("%lx-%x-%x",gu.Data1,gu.Data2,gu.Data3);
return os<<(int)b[0]<<(int)b[1]<<'-'<<(int)b[2]<<(int)b[3]<<(int)b[4]<<(int)b[5]<<(int)b[6]<<(int)b[7]<<dec;
}
*/
int main(int argc,char **argv) {
char *filename=argv[1];
HANDLE WINAPI  handleuit=CreateFile(
	  filename,	// address of name of the file 
	  GENERIC_READ,	// access (read-write) mode 
	  FILE_SHARE_READ|FILE_SHARE_WRITE,	// share mode 
	  NULL,	// address of security descriptor 
	  OPEN_EXISTING,	// how to create 
	  FILE_ATTRIBUTE_READONLY,	// file attributes 
	  NULL 	// handle of file with attributes to copy  
	 );

if(handleuit==INVALID_HANDLE_VALUE)
{
	cerr<<"Can't open "<<filename<<endl;
	exit(2);
	}
PARTITION_INFORMATION_EX pinfo;
DWORD ret;
if(!DeviceIoControl(
  handleuit,
IOCTL_DISK_GET_PARTITION_INFO_EX, // dwIoControlCode
  NULL,                             // lpInBuffer
  0,                                // nInBufferSize
  &pinfo,             // output buffer
  sizeof(pinfo),           // size of output buffer
  &ret,        // number of bytes returned
  NULL      // OVERLAPPED structure
)) {
	cerr<< filename <<" IOCTL_DISK_GET_PARTITION_INFO_EX failed\n";
 CloseHandle(handleuit) ;
exit(3);
}


switch( pinfo.PartitionStyle) {
  case PARTITION_STYLE_MBR: cout<<"MBR"<<endl;

if(pinfo.Mbr.PartitionType>=0&& pinfo.Mbr.PartitionType<0x100)
	cout<<systypes[pinfo.Mbr.PartitionType]<<endl;
/*
	switch( pinfo.Mbr.PartitionType) {
	case PARTITION_ENTRY_UNUSED: cout<<"PARTITION_ENTRY_UNUSED"<<endl;break;
	case PARTITION_FAT_12: cout<<"PARTITION_FAT_12"<<endl;break;
	case PARTITION_XENIX_1: cout<<"PARTITION_XENIX_1"<<endl;break;
	case PARTITION_XENIX_2: cout<<"PARTITION_XENIX_2"<<endl;break;
	case PARTITION_FAT_16: cout<<"PARTITION_FAT_16"<<endl;break;
	case PARTITION_EXTENDED: cout<<"PARTITION_EXTENDED"<<endl;break;
	case PARTITION_HUGE: cout<<"PARTITION_HUGE"<<endl;break;
	case PARTITION_IFS: cout<<"PARTITION_IFS"<<endl;break;
	case PARTITION_OS2BOOTMGR: cout<<"PARTITION_OS2BOOTMGR"<<endl;break;
	case PARTITION_FAT32: cout<<"PARTITION_FAT32"<<endl;break;
	case PARTITION_FAT32_XINT13: cout<<"PARTITION_FAT32_XINT13"<<endl;break;
	case PARTITION_XINT13: cout<<"PARTITION_XINT13"<<endl;break;
	case PARTITION_XINT13_EXTENDED: cout<<"PARTITION_XINT13_EXTENDED"<<endl;break;
	case PARTITION_PREP: cout<<"PARTITION_PREP"<<endl;break;
	case PARTITION_LDM: cout<<"PARTITION_LDM"<<endl;break;
	case PARTITION_UNIX: cout<<"PARTITION_UNIX"<<endl;break;
	case VALID_NTFT: cout<<"VALID_NTFT"<<endl;break;
	case PARTITION_NTFT: cout<<"PARTITION_NTFT"<<endl;break;
	default: cout<<"Unknown PartitionType\n";
	};
*/
	cout << "boot "<<(pinfo.Mbr.BootIndicator?"Yes":"No")<<endl;
	cout<<"Recognized "<< (pinfo.Mbr.RecognizedPartition?"Yes":"No")<<endl;
	cout<<"HiddenSectors "<< pinfo.Mbr.HiddenSectors<<endl;
break;
  case PARTITION_STYLE_GPT: 
cout<<"GPT "<<"Name: ";wcout<<pinfo.Gpt.Name;
	cout<<" Type "; 	printid(pinfo.Gpt.PartitionType);printf(" "); printguid(pinfo.Gpt.PartitionType);

	cout<<"PartitionId ";printguid(pinfo.Gpt.PartitionId);
	break;
  case PARTITION_STYLE_RAW: cout<<"RAW"<<endl;break;
	default: cout<<"Error style"<<endl;break;
	}


cout << "StartingOffset "<<pinfo.StartingOffset.QuadPart<<endl;
cout << "PartitionLength "<<pinfo.PartitionLength.QuadPart<<endl;
cout << "PartitionNumber "<<pinfo.PartitionNumber<<endl;
cout << "RewritePartition "<<((pinfo.RewritePartition==TRUE)?"Yes":"No")<<endl;
/*
#ifdef __WIDL__
typedef struct {
  unsigned long Data1;
  unsigned short Data2;
  unsigned short Data3;
  byte Data4[8];
} GUID;
#else
typedef struct _GUID {
  unsigned __LONG32 Data1;
  unsigned short Data2;
  unsigned short Data3;
  unsigned char Data4[8];
} GUID;
#endif
#endif


typedef struct _PARTITION_INFORMATION_GPT {
  GUID    PartitionType;
  GUID    PartitionId;
  ULONG64 Attributes;
  WCHAR   Name[36];
} PARTITION_INFORMATION_GPT, *PPARTITION_INFORMATION_GPT;

*/

 CloseHandle(handleuit) ;

}


